package cn.net.cpzslibs.prot.handset.newProt;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20019ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20019ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

/** 
 * @author  作者 李扬: 
 * @date 创建时间：2017-4-20 下午2:11:14 
 * @version 1.0 
 * @parameter 
 * @since  
 * @return  
 */
public class Prot20019ChaXun extends ProtBase {

	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode20019 = 20019;
	private Gson gson;
	private Prot20019ResBean resBean;
	
	public Prot20019ChaXun() {
		gson = new Gson();
	}
	public Prot20019ResBean getResBean(){
		return this.resBean;
	}
	
	public void dealQuery(SocketCreate create, Prot20019ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot20019ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20019, "开始请求");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recQueryList(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recQueryList(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20019, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20019, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Prot20019ResBean.class);
		}	
		System.err.println("resBean: " + resBean.toString());	
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot20019ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20019, bodySize);
		dos.write(bodyContent.getBytes("UTF-8"));
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	


}
